#define TARGETS 4

void getLSODTarget(const int *t, int *Height, int *Width,
	int *offset_x, int *offset_y);
void readTarget(const int *k, const int *x, const int *y, const int *w,
	const int *h, int *out_1);
void gradient(const int *a1, const int *a2, const int *a3, const int *a4,
	const int *a5, const int *a6, int *output);
void absVal(const int *x, int *output);
void vertSum(const int *in_1, const int *in_2, int *out_1);
void writeHist(const int *k, const int *w, const int *pp);
void init(int *out_1);


int main(void)
{
   int i, j, k;
   int offset_x,offset_y;

   static int image[1000][1000];
   static int vertEdges[1000][1000];
   static int av[1000][1000];
   static int vsum[1000];
   static int TH[TARGETS];
   static int TW[TARGETS];
#pragma value_bounds TH 10 1000
#pragma value_bounds TW 10 1000
   
   for (k = 0; k < TARGETS; k++) {
      getLSODTarget(&k, &TH[k], &TW[k], &offset_x, &offset_y);
   
      for (j = 0; j < TH[k]; j++)
	  for (i = 0; i < TW[k]; i++)
	    readTarget(&k, &i, &j, &offset_x, &offset_y, &image[j][i]);   

      for (i = 1; i < TW[k]-1; i++)
	  init(&vsum[i]);  

      for (j = 1; j < TH[k] - 1; j++) {
	  for (i = 1; i < TW[k] - 1; i++) {
	      gradient(&image[j-1][i-1], &image[j][i-1], &image[j+1][i-1],
			&image[j-1][i+1], &image[j][i+1], &image[j+1][i+1],
			&vertEdges[j][i]);
	      absVal(&vertEdges[j][i], &av[j][i]);
	  }
      }

      for (j = 1; j < TH[k] - 1; j++)
	  for (i = 1; i < TW[k] - 1; i++)
	      vertSum(&vsum[i], &av[j][i], &vsum[i]);

      for (i = 1; i < TW[k]-1; i++)
 	  writeHist(&k, &TW[k], &vsum[i]);

   }

   return 0;
}

